package example.registrar.bean;

import java.util.WeakHashMap;

import javax.naming.InitialContext;
import javax.naming.NamingException;

public class BeanRegistrar
{
	private static BeanRegistrar instance = null;
	
	private InitialContext context;
	private WeakHashMap<String, Object> jndiNameCache;
	
	private BeanRegistrar()
	{
		jndiNameCache = new WeakHashMap<String, Object>();
	}
	
	public static BeanRegistrar getInstance()
	{
		if (instance == null)
		{
			instance = new BeanRegistrar();
			
			try
			{
				instance.context = new InitialContext();
			}
			catch (NamingException e)
			{
				e.printStackTrace();
			}
		}
		return instance;
	}
	
	public Object lookupBean(String jndiName)
	{
		Object obj = null;
		
		if (jndiNameCache.containsKey(jndiName))
		{
			obj = jndiNameCache.get(jndiName);
		}
		else
		{
			try
			{
				obj = context.lookup(jndiName);
				System.out.println("BeanRegistrar lookup classloader: " + obj.getClass().getClassLoader());
			}
			catch (NamingException e)
			{
				e.printStackTrace();
			}
		}
		
		return obj;
	}
}
